-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.5.19


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema gpx_db
--

CREATE DATABASE IF NOT EXISTS gpx_db;
USE gpx_db;

--
-- Definition of table `symtbl`
--

DROP TABLE IF EXISTS `symtbl`;
CREATE TABLE `symtbl` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `desc` varchar(45) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

--
-- Dumping data for table `symtbl`
--

/*!40000 ALTER TABLE `symtbl` DISABLE KEYS */;
/*!40000 ALTER TABLE `symtbl` ENABLE KEYS */;


--
-- Definition of table `trk`
--

DROP TABLE IF EXISTS `trk`;
CREATE TABLE `trk` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `DisplayColor` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 COMMENT='track';

--
-- Dumping data for table `trk`
--

/*!40000 ALTER TABLE `trk` DISABLE KEYS */;
/*!40000 ALTER TABLE `trk` ENABLE KEYS */;


--
-- Definition of table `trkpt`
--

DROP TABLE IF EXISTS `trkpt`;
CREATE TABLE `trkpt` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `trk_id` int(10) unsigned NOT NULL,
  `nseg` int(10) unsigned NOT NULL DEFAULT '1',
  `p` point NOT NULL,
  `ptime` datetime NOT NULL,
  `ele` double DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 COMMENT='Track Points';

--
-- Dumping data for table `trkpt`
--

/*!40000 ALTER TABLE `trkpt` DISABLE KEYS */;
/*!40000 ALTER TABLE `trkpt` ENABLE KEYS */;


--
-- Definition of table `wpt`
--

DROP TABLE IF EXISTS `wpt`;
CREATE TABLE `wpt` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `p` point NOT NULL,
  `name` varchar(45) NOT NULL,
  `ele` double DEFAULT NULL,
  `cmt` datetime DEFAULT NULL,
  `sym` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 COMMENT='waypoint';

--
-- Dumping data for table `wpt`
--

/*!40000 ALTER TABLE `wpt` DISABLE KEYS */;
/*!40000 ALTER TABLE `wpt` ENABLE KEYS */;


--
-- Definition of function `LS_AddPoint`
--

DROP FUNCTION IF EXISTS `LS_AddPoint`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `LS_AddPoint`(Ls LineString, np point) RETURNS linestring
BEGIN
  Declare I, ICount Integer default 1;
  Declare nStr longText;
  Declare crP Point;
  Set ICount = NumPoints(Ls) + 1;
  Set nStr = 'LineString(';
  while I < ICount do
   Set crP = PointN(Ls, I);
   Set nStr = Concat(nStr, X(crP), ' ', Y(crP), ',');
   set I = I + 1;
  end while;
  Set nStr = Concat(nStr, X(nP), ' ', Y(nP), ')');
  Return LineFromText(nStr);
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `CreateTrkLine`
--

DROP PROCEDURE IF EXISTS `CreateTrkLine`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `CreateTrkLine`(nid int)
BEGIN
  Declare done int default 0;
  declare coup, i int default 0;
  Declare p1, p2, CrP point;
  Declare CrLn LineString;
  Declare Cur1 Cursor for
   SELECT p FROM `gpx_db`.`trkpt` where trk_id=nid and nseg=1;
  Declare Continue Handler For not found set done = 1;

  Open Cur1;
  Repeat
   Fetch Cur1 into CrP;
    if Not Done then
     case i
      when 0 then
       Set p1 = geomfromtext(concat('Point(', X(CrP), ' ', Y(CrP), ')'));
      when 1 then
       Set CrLn = geometryfromtext(concat('LineString(',x(p1),' ',y(p1),',',x(CrP),' ',y(CrP),')'));
      else
       Set CrLn = `LS_AddPoint`(CrLn, CrP);
     end case;
     Set i=i+1;
    End if;
  Until done End Repeat;
  Close Cur1;

  update trk set `trk_line`=CrLn where id=nid;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
